#!/bin/sh
#-------------------------------------------------------------------------
#
# dropuser--
#    Utility for removing a user from the PostgreSQL database.
#
# Portions Copyright (c) 1996-2001, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
#    $Header: /cvsroot/pgsql/src/bin/scripts/Attic/dropuser,v 1.14 2001/09/30 22:17:51 momjian Exp $
#
# Note - this should NOT be setuid.
#
#-------------------------------------------------------------------------

CMDNAME=`basename "$0"`
PATHNAME=`echo $0 | sed "s,$CMDNAME\$,,"`

PSQLOPT=
forcedel=t
DelUser=

# Check for echo -n vs echo \c

if echo '\c' | grep -s c >/dev/null 2>&1
then
    ECHO_N="echo -n"
    ECHO_C=""
else
    ECHO_N="echo"
    ECHO_C='\c'
fi


while [ "$#" -gt 0 ]
do
    case "$1" in
	--help|-\?)
		usage=t
                break
		;;
# options passed on to psql
	--host|-h)
		PSQLOPT="$PSQLOPT -h $2"
		shift;;
        -h*)
                PSQLOPT="$PSQLOPT $1"
                ;;
        --host=*)
                PSQLOPT="$PSQLOPT -h "`echo $1 | sed 's/^--host=//'`
                ;;
	--port|-p)
		PSQLOPT="$PSQLOPT -p $2"
		shift;;
        -p*)
                PSQLOPT="$PSQLOPT $1"
                ;;
        --port=*)
                PSQLOPT="$PSQLOPT -p "`echo $1 | sed 's/^--port=//'`
                ;;
# Note: These two specify the user to connect as (like in psql),
#       not the user you're dropping.
	--username|-U)
		PSQLOPT="$PSQLOPT -U $2"
		shift;;
        -U*)
                PSQLOPT="$PSQLOPT $1"
                ;;
        --username=*)
                PSQLOPT="$PSQLOPT -U "`echo $1 | sed 's/^--username=//'`
                ;;
	--password|-W)
		PSQLOPT="$PSQLOPT -W"
		;;
	--echo|-e)
		PSQLOPT="$PSQLOPT -e"
		;;
	--quiet|-q)
		PSQLOPT="$PSQLOPT -o /dev/null"
		;;
# other options
	--interactive|-i)
		forcedel=f
		;;
	-*)
		echo "$CMDNAME: invalid option: $1" 1>&2
                echo "Try '$CMDNAME --help' for more information." 1>&2
		exit 1
		;;
         *)
		DelUser="$1"
		;;
    esac
    shift;
done


if [ "$usage" ]; then
	echo "$CMDNAME removes a PostgreSQL user."
        echo
	echo "Usage:"
        echo "  $CMDNAME [options] [username]"
        echo
	echo "Options:"
	echo "  -h, --host=HOSTNAME             Database server host"
	echo "  -p, --port=PORT                 Database server port"
	echo "  -U, --username=USERNAME         Username to connect as (not the one to drop)"
	echo "  -W, --password                  Prompt for password to connect"
	echo "  -i, --interactive               Prompt before deleting anything"
        echo "  -e, --echo                      Show the query being sent to the backend"
        echo "  -q, --quiet                     Don't write any messages"
	echo
	echo "Report bugs to <pgsql-bugs@postgresql.org>."
	exit 0
fi

# Prompt for username if missing

if [ -z "$DelUser" ]; then
	$ECHO_N "Enter name of user to delete: "$ECHO_C
	read DelUser
	[ "$?" -ne 0 ] && exit 1
fi


if [ "$forcedel" = f ]; then
	echo "User \"$DelUser\" will be permanently deleted."
	$ECHO_N "Are you sure? (y/n) "$ECHO_C
	read REPLY

	[ "$?" -eq 1 ] && exit 1
	[ "$REPLY" != "y" -a "$REPLY" != "Y" ] && exit 0
fi


DelUser=`echo "$DelUser" | sed 's/\"/\\\"/g'`

${PATHNAME}psql $PSQLOPT -d template1 -c "DROP USER \"$DelUser\""

if [ "$?" -ne 0 ]; then
	echo "$CMDNAME: deletion of user \"$DelUser\" failed" 1>&2
	exit 1
fi

exit 0
